/*global define, CKEDITOR, setTimeout*/
/*jslint regexp: true, unparam: true*/
define(['testsuite/qunit', 'jquery', 'ep/ui/editor', '$ready!'], function (QUnit, $) {
    'use strict';

    QUnit.module("ckeditor/plugins/eplistgroup");

    var editor1 = $('#uieditor_ckeditortestinstance_test1');

    function selectElementById(id, editorInstance) {
        editorInstance.getSelection().selectElement(editorInstance.document.getById(id));
        return;
    }

    // Instantiate CKE.
    editor1.uiEditor({
        'name' : 'ckeditortestinstance_test1',
        'blogPostMode': true
    });

    setTimeout(function () {

        QUnit.asyncTest("basic eplistgroup plugin tests", function () {
            var editorId = 'uieditor_ckeditortestinstance_test1',
                editorClass = 'cke_1',
                editorInstance = CKEDITOR.instances[editorId],
                menuEntries;

            // Reset CKE data.
            editorInstance.setData('');
            // Check if eplistgroup button exists.
            QUnit.equal($('.' + editorClass + ' .cke_button__eplistgroup').length, 1, 'the necessary eplistgroup button exists');
            // Open submenu.
            $('.' + editorClass + ' .cke_button__eplistgroup').trigger('click');

            setTimeout(function () {

                QUnit.equal($('iframe.cke_panel_frame').length, 1, 'submenu is initialized');
                QUnit.equal($('iframe.cke_panel_frame').is(':visible'), true, 'submenu is open');

                // Get all menu entries.
                menuEntries = $('iframe.cke_panel_frame').contents().find('span.cke_menuitem');
                QUnit.equal(menuEntries.length, 2, 'submenu contains 2 entries');

                // Insert a p-tag foreach menu entry.
                menuEntries.each(function (index) {
                    editorInstance.insertHtml('<p id="id_' + index + '">' + $(this).find('a').text() + '</p><br />');
                });

                setTimeout(function () {
                    // Perform listformattings on p-tags.
                    menuEntries.each(function (index) {
                        selectElementById('id_' + index, editorInstance);
                        menuEntries.eq(index).find('a').trigger('click');
                    });

                    // Close submenu.
                    editorInstance.focus();

                    setTimeout(function () {
                        QUnit.equal($('iframe.cke_panel_frame').is(':visible'), false, 'submenu is closed');

                        setTimeout(function () {
                            var data = editorInstance.getData(),
                                fragment = $("<div />"),
                                ul = $(fragment).html(data).children('ul:first'),
                                ol = $(fragment).html(data).children('ol:first');

                            QUnit.ok(ul.length === 1, 'sorted list inserted');
                            QUnit.ok(ol.length === 1, 'unsorted list inserted');
                            QUnit.ok(ul.children('li').length === 1, 'one sorted list entry');
                            QUnit.ok(ol.children('li').length === 1, 'one unsorted list entry');

                            QUnit.start();
                        }, 200);
                    }, 200);
                }, 500);

            }, 1000);
        });

    }, 2000);
});