/*jslint browser: true*/
/*global define*/
define('de_epages/externalcontent/gadgetdialog/googleplus-view', [
    'jquery',
    './constants',
    './config-view',
    '$tmpl!./googleplus-view',
    '$dict!../dictionary',

    '../ui/googleplus' // The gadget to configure.
], function ($, CONSTANTS, ConfigView, template, dict) {

    'use strict';

    return ConfigView.extend({
        alias: 'googleplus',
        dict: dict,
        template: template,
        events: ConfigView.events,
        renderPreview: function () {
            var self = this,
                preview = self.elements.preview,
                parent = preview.parent(),
                gadgetPath = CONSTANTS.gWidgetNamespace + self.alias.charAt(0).toUpperCase() + self.alias.slice(1);
            setTimeout(function () {
                preview.remove();
                preview = self.elements.preview = $('<div class="PreviewNode">').appendTo(parent);
                preview[gadgetPath](self.gOptions);
            }, 1);
        }
    });
});